//+------------------------------------------------------------------+
//| basic idea for this indicator                                    |
//| given by newtrader100 and ValeoFX                                |
//+------------------------------------------------------------------+
#property copyright   "mladen"
#property link        "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 1
#property indicator_color1  DeepSkyBlue
#property indicator_width1  2

//
//
//
//
//

extern string TimeFrames        = "M1;M5;M15;M30;H1;H4;D1;W1;MN";
extern string TimeFramesWeights = "1;1;1;1;1;1;1;1;1";
extern int    PeriodRSI         =13;
extern int    PeriodStoch       = 8;
extern int    PeriodSK          = 5;
extern int    PeriodSD          = 3;
extern int    MAMode            = 0;
extern bool   alertsOn          = true;
extern bool   alertsOnCurrent   = true;
extern double alertsLevel       = 5;
extern bool   alertsMessage     = true;
extern bool   alertsSound       = false;
extern bool   alertsEmail       = false;


//
//
//
//
//

double SK[];
double SD[];
double StoRSI[];
double RSI[];
double trendsBuffer[];
double weights[];
int    timeFrames[];

//
//
//
//
//

int    totalTimeFrames;
int    minimalTimeFrame;
string indicatorFileName;
bool   calculatingValue;
bool   returnBars;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,SK);
   SetIndexBuffer(1,SD);
   SetIndexBuffer(2,StoRSI);
   SetIndexBuffer(3,RSI);
   SetIndexBuffer(4,trendsBuffer);
      indicatorFileName = WindowExpertName();
      calculatingValue  = (TimeFrames=="calculateValue"); if (calculatingValue) return(0);
      returnBars        = (TimeFrames=="returnBars");     if (returnBars)       return(0);
   
   //
   //
   //
   //
   //
   
         TimeFrames = StringTrimLeft(StringTrimRight(TimeFrames));
         if (StringSubstr(TimeFrames,StringLen(TimeFrames),1) != ";")
                          TimeFrames = StringConcatenate(TimeFrames,";");

         //
         //
         //
         //
         //                                   
            
         double tempTimeFrames[];            
            int s = 0;
            int i = StringFind(TimeFrames,";",s);

                  while (i > 0)
                  {
                     string current = StringSubstr(TimeFrames,s,i-s);
                     int time       = stringToTimeFrame(current);
                     if (time > 0) {
                           ArrayResize(tempTimeFrames,ArraySize(tempTimeFrames)+1);
                                       tempTimeFrames[ArraySize(tempTimeFrames)-1] = time; }                                 
                                       s = i + 1;
                                           i = StringFind(TimeFrames,";",s);
                  }               

         //
         //
         //    remove duplicate time frames
         //
         //
                              
            totalTimeFrames = ArraySize(tempTimeFrames);
                  for (i=0;   i<totalTimeFrames; i++)
                  for (s=i+1; s<totalTimeFrames; s++) if (tempTimeFrames[i]==tempTimeFrames[s]) tempTimeFrames[i] = -1;
                  for (i=0;   i<totalTimeFrames; i++)
                     if (tempTimeFrames[i]!=-1)
                     {            
                        ArrayResize(timeFrames,ArraySize(timeFrames)+1);
                                    timeFrames[ArraySize(timeFrames)-1] = tempTimeFrames[i];
                     }

                     //
                     //
                     //
                     //
                     //
            
                     totalTimeFrames = ArraySize(timeFrames);
                     minimalTimeFrame = PERIOD_MN1;
                     for (i=0; i<totalTimeFrames; i++)            
                              minimalTimeFrame = MathMin(minimalTimeFrame,timeFrames[i]);
         
         //
         //
         //
         //
         //
           
         TimeFramesWeights = StringTrimLeft(StringTrimRight(TimeFramesWeights));
         if (StringSubstr(TimeFramesWeights,StringLen(TimeFramesWeights),1) != ";")
                          TimeFramesWeights = StringConcatenate(TimeFramesWeights,";");
                                 ArrayResize(weights,totalTimeFrames);
                                 ArrayInitialize(weights,1);
            //
            //
            //
            //
            //
            
            int k = 0;             
                s = 0;
                i = StringFind(TimeFramesWeights,";",s);
                while (i > 0)
                {
                  string currenw    = StringSubstr(TimeFramesWeights,s,i-s);
                         weights[k] = StrToDouble(currenw);
                                  s = i + 1;
                                  k = k + 1;
                                  i = StringFind(TimeFramesWeights,";",s);
            }
            
         
   //
   //
   //
   //
   //
   
   SetLevelValue(0, 0);
   SetLevelValue(1, alertsLevel);
   SetLevelValue(2,-alertsLevel);
   return(0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { SK[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

      if (calculatingValue)
      {  
         for(i=limit; i>=0; i--)
         {
            RSI[i] = iRSI(NULL,0,PeriodRSI,PRICE_CLOSE,i);
            double LLV = RSI[ArrayMinimum(RSI,PeriodStoch,i)];
            double HHV = RSI[ArrayMaximum(RSI,PeriodStoch,i)];
            if ((HHV-LLV)!=0)
                  StoRSI[i] = 100.0*((RSI[i] - LLV)/(HHV - LLV));
            else  StoRSI[i] = 0;
         }   
         for(i=limit; i>=0; i--) SK[i]=iMAOnArray(StoRSI,0,PeriodSK,0,MAMode,i);
         for(i=limit; i>=0; i--)
         {
            SD[i]           = iMAOnArray(SK,0,PeriodSD,0,MAMode,i);
            trendsBuffer[i] = trendsBuffer[i+1];
               if (SK[i]>SD[i]) trendsBuffer[i]= 1;
               if (SK[i]<SD[i]) trendsBuffer[i]=-1;
         }            
         return(0);
      }
   
   //
   //
   //
   //
   //

      if (Period()>minimalTimeFrame)
      {
            Comment("you should use this indicator on "+timeFrameToString(minimalTimeFrame)+" period");
            return(0);
      }     
      
      //
      //
      //
      //
      //
      
      for (int k=0; k<totalTimeFrames; k++) limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrames[k],indicatorFileName,"returnBars",0,0)*timeFrames[k]/Period()));
      for (i=limit; i>=0; i--)
      {
         SK[i]=0;
         
         //
         //
         //
         //
         //
         
            for (k=0; k<totalTimeFrames; k++)
            {
               int y = iBarShift(NULL,timeFrames[k],Time[i]);
                     SK[i] += weights[k]*iCustom(NULL,timeFrames[k],indicatorFileName,"calculateValue","",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,MAMode,4,y);
            }

         //
         //
         //
         //
         //
         
         trendsBuffer[i] = 0;
         if (MathAbs(SK[i])>=alertsLevel)
            if (SK[i]>0) trendsBuffer[i] =  1;
            else         trendsBuffer[i] = -1;
      }

   //
   //
   //
   //
   //
   
   manageAlerts();
   return(0);	
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1;
      if (trendsBuffer[whichBar] ==  1) doAlert(whichBar,"up"  ,SK[whichBar]);
      if (trendsBuffer[whichBar] == -1) doAlert(whichBar,"down",SK[whichBar]);
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat,double value)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," ",timeFrameToString(Period())," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," DTosc alligned to value "+DoubleToStr(value,2)+" trend changed to ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"DTOsc's "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(iTfTable[i]);
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}